using UnityEngine;
using UnityEditor;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Linq;
using Unity.Mathematics;
public enum RotationType
{
    Local,
    Global
}
public class AnimationMirror : MonoBehaviour
{
    /*
    [Header("Set your rotation type")]
    public RotationType rotationType = RotationType.Local;

    public bool CorrectThumb = false;
    public bool ExchangeXY = false;
    public bool ExchangeYZ = false;
    public bool ExchangeXZ = false;

    public bool FlipX = false;
    public bool FlipY = false;
    public bool FlipZ = false;

    public bool ExchangeXYThumb = false;
    public bool ExchangeYZThumb = false;
    public bool ExchangeXZThumb = false;

    public bool FlipXThumb = false;
    public bool FlipYThumb = false;
    public bool FlipZThumb = false;
    public bool FlipWThumb = false;
*/
    [Header("Set your hand bones here")]
    public GameObject RightHand;
    public GameObject Root;
    public GameObject Thumb1;
    public GameObject Thumb2;
    public GameObject Thumb3;
    public GameObject Index1;
    public GameObject Index2;
    public GameObject Index3;
    public GameObject Middle1;
    public GameObject Middle2;
    public GameObject Middle3;
    public GameObject Ring1;
    public GameObject Ring2;
    public GameObject Ring3;
    public GameObject Pinky1;
    public GameObject Pinky2;
    public GameObject Pinky3;

    [Header("Test Animation Bones")]
    public Transform TestRightHand;
    public Transform TestRoot;
    public Transform TestThumb1;
    public Transform TestThumb2;
    public Transform TestThumb3;
    public Transform TestIndex1;
    public Transform TestIndex2;
    public Transform TestIndex3;
    public Transform TestMiddle1;
    public Transform TestMiddle2;
    public Transform TestMiddle3;
    public Transform TestRing1;
    public Transform TestRing2;
    public Transform TestRing3;
    public Transform TestPinky1;
    public Transform TestPinky2;
    public Transform TestPinky3;

    //public Transform TestThumbInHand;

    Quaternion ThumbInHandRot = new Quaternion();


    Dictionary<Transform, Transform> BonePairs = new Dictionary<Transform, Transform>();
    void Start()
    {
        SetBonePairs();
    }

    void Update()
    {
        SetLocalRotation();
        /*
       if(rotationType == RotationType.Local){
           SetLocalRotation();
       }else{
           SetGlobalRotation();
       }
       */
    }
    void SetLocalRotation(){
        for (int i = 0; i < BonePairs.Count; i++)
        {
            BonePairs.ElementAt(i).Value.localRotation = Quaternion.Euler(BonePairs.ElementAt(i).Key.localEulerAngles);
        }
            
    }
/*
    void SetLocalRotation(){
        //ThumbInHandRot = TestThumbInHand.localRotation;
        Quaternion NewThumbRot = TestThumb1.rotation * Quaternion.Inverse(TestRightHand.rotation);
        for (int i = 0; i < BonePairs.Count; i++)
        {
            if (!BonePairs.ElementAt(i).Key.name.Contains("thumb1", System.StringComparison.CurrentCultureIgnoreCase))
            {
                BonePairs.ElementAt(i).Value.localRotation = Quaternion.Euler(BonePairs.ElementAt(i).Key.localRotation.eulerAngles);
                if (ExchangeXY)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                }
                else if (ExchangeYZ)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.w);
                }
                else if (ExchangeXZ)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.w);
                }

                if (FlipX)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(-BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                }

                if (FlipY)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.x, -BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                }

                if (FlipZ)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.y, -BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                }
            }
            else
            {
                BonePairs.ElementAt(i).Value.localRotation = Quaternion.Euler(BonePairs.ElementAt(i).Key.localEulerAngles);
                
                if (ExchangeXYThumb)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                    ThumbInHandRot = new Quaternion(ThumbInHandRot.y, ThumbInHandRot.x, ThumbInHandRot.z, ThumbInHandRot.w);
                }
                else if (ExchangeYZThumb)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.w);
                    ThumbInHandRot = new Quaternion(ThumbInHandRot.x, ThumbInHandRot.z, ThumbInHandRot.y, ThumbInHandRot.w);

                }
                else if (ExchangeXZThumb)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.w);
                    ThumbInHandRot = new Quaternion(ThumbInHandRot.z, ThumbInHandRot.y, ThumbInHandRot.x, ThumbInHandRot.w);

                }

                if (FlipXThumb)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(-BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                    //ThumbInHandRot = BonePairs.ElementAt(i).Value.localRotation * ThumbInHandRot;
                }

                if (FlipYThumb)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.x, -BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                    //ThumbInHandRot = BonePairs.ElementAt(i).Value.localRotation * ThumbInHandRot;
                }

                if(FlipZThumb){
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.y, -BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                    //ThumbInHandRot = BonePairs.ElementAt(i).Value.localRotation * ThumbInHandRot;
                }

                if (FlipWThumb)
                {
                    BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.y, BonePairs.ElementAt(i).Value.localRotation.z, -BonePairs.ElementAt(i).Value.localRotation.w);
                    //BonePairs.ElementAt(i).Value.localRotation = new Quaternion(BonePairs.ElementAt(i).Value.localRotation.x, BonePairs.ElementAt(i).Value.localRotation.y, -BonePairs.ElementAt(i).Value.localRotation.z, BonePairs.ElementAt(i).Value.localRotation.w);
                    //ThumbInHandRot = BonePairs.ElementAt(i).Value.localRotation * ThumbInHandRot;
                }

                if (CorrectThumb && BonePairs.ElementAt(i).Key.name.Contains("thumb1", System.StringComparison.CurrentCultureIgnoreCase))
                {
                    //Quaternion 
                    BonePairs.ElementAt(i).Value.localRotation = NewThumbRot;

                }
            }
        }
    }

    void SetGlobalRotation(){
        for (int i = 0; i < BonePairs.Count; i++)
        {
            if (!BonePairs.ElementAt(i).Key.name.Contains("thumb", System.StringComparison.CurrentCultureIgnoreCase))
            {
                BonePairs.ElementAt(i).Value.rotation = BonePairs.ElementAt(i).Key.rotation;
                if (ExchangeXY)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(BonePairs.ElementAt(i).Value.rotation.y, BonePairs.ElementAt(i).Value.rotation.x, BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.w);
                }
                else if (ExchangeYZ)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(BonePairs.ElementAt(i).Value.rotation.x, BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.y, BonePairs.ElementAt(i).Value.rotation.w);
                }
                else if (ExchangeXZ)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.y, BonePairs.ElementAt(i).Value.rotation.x, BonePairs.ElementAt(i).Value.rotation.w);
                }

                if (FlipX)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(-BonePairs.ElementAt(i).Value.rotation.x, BonePairs.ElementAt(i).Value.rotation.y, BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.w);
                }

                if (FlipY)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(BonePairs.ElementAt(i).Value.rotation.x, -BonePairs.ElementAt(i).Value.rotation.y, BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.w);
                }

                if (FlipZ)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(BonePairs.ElementAt(i).Value.rotation.x, BonePairs.ElementAt(i).Value.rotation.y, -BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.w);
                }
            }
            else
            {
                BonePairs.ElementAt(i).Value.rotation = BonePairs.ElementAt(i).Key.rotation;
                if (ExchangeXYThumb)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(BonePairs.ElementAt(i).Value.rotation.y, BonePairs.ElementAt(i).Value.rotation.x, BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.w);
                }
                else if (ExchangeYZThumb)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(BonePairs.ElementAt(i).Value.rotation.x, BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.y, BonePairs.ElementAt(i).Value.rotation.w);
                }
                else if (ExchangeXZThumb)
                {
                    BonePairs.ElementAt(i).Value.rotation = new Quaternion(BonePairs.ElementAt(i).Value.rotation.z, BonePairs.ElementAt(i).Value.rotation.y, BonePairs.ElementAt(i).Value.rotation.x, BonePairs.ElementAt(i).Value.rotation.w);
                }
            }
        }
    }
*/
    void SetBonePairs()
    {
        BonePairs.Add(TestRightHand, RightHand.transform);
        BonePairs.Add(TestRoot, Root.transform);
        BonePairs.Add(TestThumb1, Thumb1.transform);
        BonePairs.Add(TestThumb2, Thumb2.transform);
        BonePairs.Add(TestThumb3, Thumb3.transform);
        BonePairs.Add(TestIndex1, Index1.transform);
        BonePairs.Add(TestIndex2, Index2.transform);
        BonePairs.Add(TestIndex3, Index3.transform);
        BonePairs.Add(TestMiddle1, Middle1.transform);
        BonePairs.Add(TestMiddle2, Middle2.transform);
        BonePairs.Add(TestMiddle3, Middle3.transform);
        BonePairs.Add(TestRing1, Ring1.transform);
        BonePairs.Add(TestRing2, Ring2.transform);
        BonePairs.Add(TestRing3, Ring3.transform);
        BonePairs.Add(TestPinky1, Pinky1.transform);
        BonePairs.Add(TestPinky2, Pinky2.transform);
        BonePairs.Add(TestPinky3, Pinky3.transform);
    }
}
