using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;
[ExecuteInEditMode]
public class CameraOrbit : MonoBehaviour {

    public Transform target;
    public float distance;
    float xSpeed = 60.0f;
    float ySpeed = 60.0f;

    public float yMinLimit = -80f;
    public float yMaxLimit = 80f;

    public float distanceMin;
    public float distanceMax;

    public float scrollSpeed;

    public float x = 0.0f;
    public float y = 0.0f;
    public float z = 0.0f;

    public Camera cam;
    // Start is called before the first frame update
    void Start() {

    }

    // Update is called once per frame
    void Update() {

    }

    private void LateUpdate() {
        if (Input.GetMouseButton(1)) {
            x += Input.GetAxis("Mouse X") * xSpeed * distance * 0.02f;
            y -= Input.GetAxis("Mouse Y") * ySpeed * distance * 0.02f;
        }

        if (cam.pixelRect.Contains(Input.mousePosition)) {
            distance = Mathf.Clamp(distance - Input.GetAxis("Mouse ScrollWheel") * scrollSpeed, distanceMin, distanceMax);
            
        }

        y = ClampAngle(y, yMinLimit, yMaxLimit);
        Quaternion rotation = Quaternion.Euler(y, x, z);

        //RaycastHit hit;
        /*
        if (Physics.Linecast(target.position, transform.position, out hit)) {
            distance -= hit.distance;
        }
        */
        Vector3 negDistance = new Vector3(0.0f, 0.0f, -distance);
        Vector3 position = rotation * negDistance + target.position;
        //position -= new Vector3(0,2,0);

        transform.rotation = rotation;
        transform.position = position;
    }

    public static float ClampAngle(float angle, float min, float max) {
        if (angle < -360F)
            angle += 360F;
        if (angle > 360F)
            angle -= 360F;
        return Mathf.Clamp(angle, min, max);
    }
}
